# -*- coding: utf-8 -*-
# @Time    : 2024/5/16
# @Author  : 魏志亮

import logging
import os
import datetime
import sys

logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)
stout_handle = logging.StreamHandler(sys.stdout)
stout_handle.setFormatter(logging.Formatter("%(asctime)s-%(levelname)s-%(filename)-8s:%(lineno)s: %(message)s"))
stout_handle.setLevel(logging.INFO)
logger.addHandler(stout_handle)


def init_log(batch_no, name, type):
    log_path = os.path.dirname(os.path.dirname(os.path.dirname(__file__))) + '/logs'
    file_path = os.path.join(log_path, str(name), str(batch_no), str(type))

    if not os.path.exists(file_path):
        os.makedirs(file_path, exist_ok=True)
    file_name = file_path + os.sep + str(datetime.date.today()) + '.log'

    file_handler = logging.FileHandler(file_name, encoding='utf-8')
    file_handler.setFormatter(logging.Formatter("%(asctime)s-%(levelname)s-%(filename)-8s:%(lineno)s: %(message)s"))
    file_handler.setLevel(logging.INFO)
    logger.addHandler(file_handler)


def trans_print(*args):
    logger.info("  ".join([str(a) for a in args]))
